SystemOrganization addCategory: #GTD!
SystemOrganization addCategory: 'GTD-App'!
SystemOrganization addCategory: 'GTD-Commands'!
SystemOrganization addCategory: 'GTD-Model'!
SystemOrganization addCategory: 'GTD-ModelTests'!
SystemOrganization addCategory: 'GTD-Web'!

TestCase subclass: #AccionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-ModelTests'!

!AccionTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 7/31/2015 17:21'!
test_01_AgregarUnaDescripcion

	| textoDescripcion accion |
	
	textoDescripcion := 'Descripcion de test'.
	accion := Accion new.
	
	accion descripcion: textoDescripcion.
	
	self assert: accion descripcion = textoDescripcion.
	! !

!AccionTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 7/31/2015 17:22'!
test_02_CuandoCreoUnaAccionTieneUnaDescripcionPorDefecto

	| accion |
	accion := Accion new.
	self assert: accion descripcion = 'New action'.! !

TestCase subclass: #AgenteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-ModelTests'!

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/27/2015 22:34'!
newAgenteDePrueba

	^Agente example.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/27/2015 22:33'!
test_01_AltaDeUnProyecto
	| agente  |
	
	agente := Agente new.
	self assert: agente proyectos isEmpty.
	agente addProyecto: Proyecto example.
	self assert: agente proyectos notEmpty.
! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:28'!
test_02_CualesSonLasNextActions
	| agente acciones descripcionDeLaAccionEsperada |

	agente := self newAgenteDePrueba.
	acciones := agente nextActions.
	descripcionDeLaAccionEsperada := 'Llamar al dentista para pedir un turno'.
	
	self assert: acciones anyOne descripcion = descripcionDeLaAccionEsperada.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:30'!
test_03_MarcarUnaNextActionComoHecha

	| agente accionAMarcar descripcionDeLaAccionAMarcar descripcionDeLaAccionSiguiente |
	
	agente := self newAgenteDePrueba.
	descripcionDeLaAccionAMarcar :=  'Llamar al dentista para pedir un turno'.
	descripcionDeLaAccionSiguiente := 'Agregar el turno a mi calendario'.
	accionAMarcar := agente nextActions anyOne.
	
	self assert: accionAMarcar descripcion = descripcionDeLaAccionAMarcar.
	agente marcarComoHecha: accionAMarcar.
	self assert: agente nextActions anyOne descripcion = descripcionDeLaAccionSiguiente.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:32'!
test_04_MarcarUnaNoNextActionComoHecha

	| agente accionAMarcar descripcionDeLaAccionAMarcar descripcionDeLaAccionSiguiente proyecto |
	
	agente := self newAgenteDePrueba.
	descripcionDeLaAccionAMarcar :=  'Cargar la tarjeta SUBE'.
	descripcionDeLaAccionSiguiente := 'Llamar al dentista para pedir un turno'.
	proyecto := agente proyectos first.
	accionAMarcar := proyecto acciones last.
	
	self assert: accionAMarcar descripcion = descripcionDeLaAccionAMarcar.
	self deny: (proyecto isHecha: accionAMarcar).
	agente marcarComoHecha: accionAMarcar.
	self assert: agente nextActions anyOne descripcion = descripcionDeLaAccionSiguiente.
	self assert: (proyecto isHecha: accionAMarcar).
	! !

TestCase subclass: #ProyectoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-ModelTests'!

!ProyectoTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:24'!
test_01_AgregarUnaAccionAUnProyecto
	
	| proyecto accionPorAgregar |
	proyecto := Proyecto new.
	accionPorAgregar := Accion descripcion: 'Accion de test'.
	
	self assert: proyecto acciones isEmpty.
	
	proyecto addAccion: accionPorAgregar.
	
	self assert: proyecto acciones notEmpty.
	! !

!ProyectoTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 8/21/2015 18:20'!
test_02_DefaultValues
	
	| proyecto  |
	proyecto := Proyecto new.

	self assert: proyecto nombre = 'New project'.
	self assert: proyecto condicionDeExito isNil.
	self assert: proyecto acciones isEmpty.
	self assert: proyecto accionesHechas isEmpty.
	! !

WAFileLibrary subclass: #GTDAppFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Web'!

!GTDAppFileLibrary methodsFor: 'as yet unclassified' stamp: 'SergioFedi 7/20/2015 18:20'!
updateRoot: anHtmlRoot
  super updateRoot: anHtmlRoot.
  anHtmlRoot title: 'GTD Application'.
  anHtmlRoot stylesheet url: 'some_sheet.css'. "(GTDAppFileLibrary urlOf: #mainCss)"! !

WAComponent subclass: #GTDWebApp
	instanceVariableNames: 'app'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Web'!

!GTDWebApp commentStamp: 'SergioFedi 7/20/2015 18:10' prior: 0!
I model the web aspect of a GTD Application!

!GTDWebApp class methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/3/2015 16:48'!
initialize
  (WAAdmin register: self asApplicationAt: 'gtd')
		preferenceAt: #sessionClass put: GTDAppSession;
		addLibrary: GTDAppFileLibrary;
		addLibrary: JQDevelopmentLibrary halt;
		yourself.! !

!GTDWebApp methodsFor: 'accessing' stamp: 'SergioFedi 7/20/2015 18:43'!
app
	app ifNil: [ self initializeApp ].
	^ app! !

!GTDWebApp methodsFor: 'accessing' stamp: 'SergioFedi 7/20/2015 18:43'!
app: anObject
	app := anObject! !

!GTDWebApp methodsFor: 'accessing' stamp: 'SergioFedi 7/20/2015 18:44'!
initializeApp
	self app: GTDApplication example.! !

!GTDWebApp methodsFor: 'as yet unclassified' stamp: 'SergioFedi 8/28/2015 16:19'!
renderContentOn: html

	super renderContentOn: html.
	html heading: 'GTD Application'.
	html anchor 
		callback: [ ]; 
		with: 'Refresh'.
	html heading
		level2;
		with: 'Projects'.
	self app agente proyectos do: [:proyecto |
		html heading
			level3;
			with: proyecto nombre.
		proyecto acciones do: [ :accion |
			html paragraph with: [
				html checkbox
					value: (proyecto isHecha: accion);
					callback: [:value | proyecto marcarComoHecha: accion];
					onClick: (html jQuery ajax serializeThisWithHidden).
				html text: accion descripcion.
				]
			]
		].! !

WASession subclass: #GTDAppSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Web'!

!GTDAppSession commentStamp: 'SergioFedi 7/20/2015 18:10' prior: 0!
I hold the state of the session a user has with the GTD Application!

!GTDAppSession methodsFor: 'as yet unclassified' stamp: 'SergioFedi 7/20/2015 18:07'!
unregistered
	super unregistered.
	"clean up resources"! !

Object subclass: #Accion
	instanceVariableNames: 'descripcion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!Accion commentStamp: '<historical>' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	descripcion:		<Object>


    Implementation Points!

!Accion class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:26'!
descripcion: aString

	^ self new descripcion: aString.! !

!Accion methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/28/2015 10:01'!
descripcion
	^ descripcion! !

!Accion methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/28/2015 10:11'!
descripcion: aTextoDescriptivo
	descripcion := aTextoDescriptivo! !

!Accion methodsFor: 'as yet unclassified' stamp: 'SergioFedi 7/31/2015 17:24'!
initialize

	self descripcion: 'New action'.! !

Object subclass: #Agente
	instanceVariableNames: 'proyectos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!Agente commentStamp: 'SergioFedi 4/24/2015 18:49' prior: 0!
Soy una entidad que tiene agencia. Es decir, que quiere lograr algo en la realidad. Por lo tanto voya tener proyectos que voy a querer llevar a cabo.!

!Agente class methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/27/2015 22:31'!
example
	| agente unProyecto  |
	
	agente := Agente new.
	unProyecto := Proyecto example.
	agente addProyecto: unProyecto.
	^ agente.! !

!Agente methodsFor: 'public' stamp: 'FedericoFigueredo 4/23/2015 11:00'!
addProyecto: aProyecto 
	self proyectos add: aProyecto.! !

!Agente methodsFor: 'initialization' stamp: 'FedericoFigueredo 4/23/2015 11:07'!
initialize

	self proyectos: OrderedCollection new.! !

!Agente methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:50'!
marcarComoHecha: anAccion 
	| proyecto | 
	
	proyecto := self proyectos detect: [ :each | each includesAccion: anAccion ].
	
	proyecto marcarComoHecha: anAccion.! !

!Agente methodsFor: 'public' stamp: 'FedericoFigueredo 4/27/2015 09:49'!
nextActions
	^ self proyectos collect: [ :aProyecto | aProyecto nextAction ].
	! !

!Agente methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 11:02'!
proyectos
	^ proyectos! !

!Agente methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 11:02'!
proyectos: anObject
	proyectos := anObject! !

Object subclass: #AppCommand
	instanceVariableNames: 'app'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Commands'!

!AppCommand commentStamp: '<historical>' prior: 0!
This class models and regulates the interaction between an external actor and the model of the application.!

!AppCommand class methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/29/2015 21:44'!
app: anApp

	^self new app: anApp.! !

!AppCommand methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 21:46'!
app
	^ app! !

!AppCommand methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 21:47'!
app: anApplication
	app := anApplication! !

AppCommand subclass: #ViewAgentsNextActionsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Commands'!

!ViewAgentsNextActionsCommand commentStamp: '<historical>' prior: 0!
I Return information that allows the renderer to display a view of an Agent's next actions.!

AppCommand subclass: #WebCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Commands'!

!WebCommand commentStamp: '<historical>' prior: 0!
This class models and regulates the interaction between a web actor and the model of the application.!

!WebCommand methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/29/2015 21:46'!
handleRequest: aRequest

	self subclassResponsibility.! !

WebCommand subclass: #WebViewAgenteCmd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Commands'!

!WebViewAgenteCmd commentStamp: '<historical>' prior: 0!
This class models and regulates the view of an Agent by a web actor.!

!WebViewAgenteCmd methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/29/2015 21:41'!
handleRequest: aRequest

	| response |
	response := ZnResponse new
		statusLine: ZnStatusLine ok;
		headers: ZnHeaders defaultResponseHeaders;
		yourself.
	response entity: self responseEntity.
	^ response! !

!WebViewAgenteCmd methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/30/2015 11:11'!
htmlForProyectActions: proyecto inStream: stream

	stream nextPutAll: '<ol class="listaDeAcciones">'; cr.
	
	proyecto acciones do: 
		[ :accion | 
		stream nextPutAll: '<li>', accion descripcion, '</li>'; cr]. 
	
	stream nextPutAll: '</ol>'; cr.! !

!WebViewAgenteCmd methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/30/2015 11:05'!
proyectosData
	| stream |
	stream := WriteStream on: String new.
	
	stream nextPutAll: '<ul class="listaDeProyectos">'; cr.
	
	self app agente proyectos do: 
		[ :proyecto | 
		stream 
			nextPutAll: '<li>'; cr;
			nextPutAll: '<div>'; cr;
			nextPutAll: '<h2>', proyecto nombre, '</h2>'; cr.
		self htmlForProyectActions: proyecto inStream: stream.
 		stream
			nextPutAll: '</div>'; cr;
			nextPutAll: '</li>'; cr.]. 
	
	stream nextPutAll: '</ul>'; cr.

	^ stream contents.! !

!WebViewAgenteCmd methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/30/2015 10:49'!
responseEntity
	| file contents data fileName |

	data := Dictionary with: 'proyectos' -> self proyectosData.
	fileName := self app configuration at: 'indexWorkingCopy'.
	file := FileStream readOnlyFileNamed: fileName.
	contents := file contents.

	file close.

	^(ZnStringEntity html: (contents format: data)).! !

Object subclass: #Application
	instanceVariableNames: 'model configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-App'!

!Application commentStamp: '<historical>' prior: 0!
This class handles the machine resources needed to host the model and allowing the interaction and persistence of it.!

!Application class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/30/2015 09:30'!
new

	^super new.! !

!Application methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 21:55'!
configuration
	configuration isNil ifTrue: [ self initializeConfiguration ].
	^ configuration! !

!Application methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 21:55'!
configuration: anObject
	configuration := anObject! !

!Application methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 22:02'!
initializeConfiguration
	
	self configuration: Dictionary new.

! !

!Application methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 21:54'!
model
	^ model! !

!Application methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 21:54'!
model: anObject
	model := anObject! !

Application subclass: #WebApplication
	instanceVariableNames: 'webserver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-App'!

!WebApplication commentStamp: '<historical>' prior: 0!
This class models an application that allows interaction with its model through the web.!

WebApplication subclass: #GTDApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-App'!

!GTDApplication commentStamp: 'SergioFedi 4/29/2015 22:05' prior: 0!
This WebApplication hosts the model of an Agent.!

!GTDApplication class methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/28/2015 09:52'!
example

	^self new agente: Agente example.! !

!GTDApplication methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 21:52'!
agente
	^self model.! !

!GTDApplication methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 21:52'!
agente: anAgente
	self model: anAgente! !

!GTDApplication methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/30/2015 10:01'!
defaultWebCommand

	^ WebViewAgenteCmd app: self.! !

!GTDApplication methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 20:54'!
newStaticHandler
	^ ZnStaticFileServerDelegate new
		directory: (ZnFileSystemUtils directory: (self configuration at: 'staticContentDirectoryPath'));
		prefixFromString: (self configuration at: 'firstURISegmentToAccessStaticContent');
		yourself! !

!GTDApplication methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/29/2015 19:33'!
start
	self webserver isRunning not ifTrue: [
		self webserver
			port: (self configuration at: 'port');
			start.
	].
! !

!GTDApplication methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/29/2015 22:07'!
stop

	webserver notNil ifTrue: [
		self webserver stop].! !

!GTDApplication methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/29/2015 21:40'!
webCommands

	^#().! !

!WebApplication methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/29/2015 22:00'!
defaultWebCommand

	self subclassResponsibility.! !

!WebApplication methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 22:03'!
initializeConfiguration
	
	super initializeConfiguration.
	self configuration at: 'port' put: 1701.! !

!WebApplication methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 22:02'!
initializeWebserver
	
	self subclassResponsibility.! !

!WebApplication methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/29/2015 22:00'!
webCommands

	self subclassResponsibility.! !

!WebApplication methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 21:58'!
webserver
	webserver isNil ifTrue: [ self initializeWebserver ].
	^ webserver! !

!WebApplication methodsFor: 'accessing' stamp: 'SergioFedi 4/29/2015 21:58'!
webserver: anObject
	webserver := anObject! !

Object subclass: #Proyecto
	instanceVariableNames: 'nombre condicionDeExito acciones accionesHechas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!Proyecto commentStamp: 'FedericoFigueredo 4/23/2015 14:28' prior: 0!
Llamamos Proyecto a un estado de la realidad deseado para el cual se requieren la realización de más de una acción.!

!Proyecto class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:23'!
example
	| unProyecto | 
	
	unProyecto := self new.
	
	unProyecto 
		addAccion: (Accion descripcion: 'Llamar al dentista para pedir un turno');
		addAccion: (Accion descripcion: 'Agregar el turno a mi calendario');
		addAccion: (Accion descripcion: 'Ir a la consulta');
		addAccion: (Accion descripcion: 'Cargar la tarjeta SUBE').
	unProyecto
		nombre: 'Chequeo Dental';
		condicionDeExito: 'Saber el estado actual de mis dientes'.
	
	^ unProyecto.! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
acciones
	^ acciones! !

!Proyecto methodsFor: 'accessing' stamp: 'SergioFedi 8/21/2015 18:14'!
acciones: anObject
	acciones := anObject! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/27/2015 10:20'!
accionesHechas
	^ accionesHechas! !

!Proyecto methodsFor: 'accessing' stamp: 'SergioFedi 8/21/2015 18:15'!
accionesHechas: anObject
	accionesHechas := anObject! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 09:54'!
addAccion: anAccion 
	self acciones add: anAccion.! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
condicionDeExito
	^ condicionDeExito! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
condicionDeExito: anObject
	condicionDeExito := anObject! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:40'!
includesAccion: anAccion 
	^ self acciones includes: anAccion.! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'SergioFedi 8/21/2015 18:19'!
initialize
	self nombre: 'New project'.
	self condicionDeExito: nil.
	self acciones: OrderedCollection new.
	self accionesHechas: OrderedCollection new.
	! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:24'!
isHecha: anAccion 
	^ self accionesHechas includes: anAccion.! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:51'!
marcarComoHecha: anAccion 
	self accionesHechas add: anAccion.! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:37'!
nextAction
	^ self acciones detect: [ :accion | (self isHecha: accion) not ].! !

!Proyecto methodsFor: 'public' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
nombre
	^ nombre! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
nombre: anObject
	nombre := anObject! !
GTDWebApp initialize!
